; Script generated by the HM NIS Edit Script Wizard.
; Forgive me, i am new at this. -- paul@cypherpunks.ca
;
; v1.99.0-1 - Bump version number, install Protocol.txt file
; v1.0.3-2 - Fix for detecting gaim if not installed by Administrator
;            bug report by Joanna Rutkowska <joanna@mailsnare.net>
;          - Fix for uninstalling the dll when not installed as Administrator
; v1.0.3   - Initial version

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "gaim-otr"
!define PRODUCT_VERSION "1.99.0-1"
!define PRODUCT_PUBLISHER "Cypherpunks CA"
!define PRODUCT_WEB_SITE "http://www.cypherpunks.ca/otr/"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "c:\gaim-otr-build\COPYING.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\README.txt"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "c:\gaim-otr-build\${PRODUCT_NAME}-${PRODUCT_VERSION}.exe"
InstallDir "$PROGRAMFILES\gaim-otr"
InstallDirRegKey HKEY_LOCAL_MACHINE SOFTWARE\Gaim-otr "Install_Dir"
;WriteRegStr HKLM "SOFTWARE\gaim-otr" "gaimdir" ""

Var "GaimDir"

ShowInstDetails show
ShowUnInstDetails show

Section "MainSection" SEC01
;InstallDir "$PROGRAMFILES\Gaim\plugins"
 ;Check for gaim installation

Call GetGaimInstPath
WriteRegStr HKLM "SOFTWARE\gaim-otr" "gaimdir" "$GaimDir"
WriteRegStr HKCU "SOFTWARE\gaim-otr" "gaimdir" "$GaimDir"

	SetOutPath "$INSTDIR"
 
 SetOverwrite ifnewer
  File "gaim-otr.dll"
	File "README.Toolkit.txt"
	File "README.txt"
	File "Protocol.txt"
	File "COPYING.txt"
	File "COPYING.LIB.txt"
	File "otr_mackey.exe"
	File "otr_modify.exe"
	File "otr_parse.exe"
	File "otr_readforge.exe"
	File "otr_remac.exe"
	File "otr_sesskeys.exe"
	File "gaim-otr.nsi"
 ; move to gaim plugin directory
	Rename "$INSTDIR\gaim-otr.dll" "$GaimDir\plugins\gaim-otr.dll"

SectionEnd

Section -AdditionalIcons
  CreateDirectory "$SMPROGRAMS\Gaim-otr"
  CreateShortCut "$SMPROGRAMS\Gaim-otr\Uninstall.lnk" "$INSTDIR\gaim-otr-uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\gaim-otr-uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\gaim-otr-uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
 
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  Delete "$INSTDIR\gaim-otr-uninst.exe"
	Delete "$INSTDIR\README.Toolkit.txt"
	Delete "$INSTDIR\README.txt"
	Delete "$INSTDIR\Protocol.txt"
	Delete "$INSTDIR\COPYING.txt"
	Delete "$INSTDIR\COPYING.LIB.txt"
	Delete "$INSTDIR\otr_mackey.exe"
	Delete "$INSTDIR\otr_modify.exe"
	Delete "$INSTDIR\otr_parse.exe"
	Delete "$INSTDIR\otr_readforge.exe"
	Delete "$INSTDIR\otr_remac.exe"
	Delete "$INSTDIR\otr_sesskeys.exe"
	Delete "$INSTDIR\gaim-otr.nsi"
  Delete "$SMPROGRAMS\Gaim-otr\Uninstall.lnk"
  RMDir "$SMPROGRAMS\Gaim-otr"
  RMDir "$INSTDIR"
  
  ReadRegStr $GaimDir HKLM Software\gaim-otr "gaimdir"
	IfFileExists "$GaimDir\plugins\gaim-otr.dll" dodelete
	
	ReadRegStr $GaimDir HKCU Software\gaim-otr "gaimdir"
	IfFileExists "$GaimDir\plugins\gaim-otr.dll" dodelete
	MessageBox MB_OK|MB_ICONINFORMATION "Could not find gaim plugin directory, gaim-otr.dll not uninstalled!"
  
	dodelete:
	Delete "$GaimDir\plugins\gaim-otr.dll"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM SOFTWARE\gaim-otr\gaimdir
  DeleteRegKey HKCU SOFTWARE\gaim-otr\gaimdir
SetAutoClose true
SectionEnd
Function GetGaimInstPath

  Push $0
  ReadRegStr $0 HKLM "Software\gaim" ""
	IfFileExists "$0\gaim.exe" cont
	ReadRegStr $0 HKCU "Software\gaim" ""
	IfFileExists "$0\gaim.exe" cont
  MessageBox MB_OK|MB_ICONINFORMATION "Failed to find GAIM installation."
		Abort "Failed to find GAIM installation. Please install GAIM first."
cont:
	StrCpy $GaimDir $0
	MessageBox MB_OK|MB_ICONINFORMATION "Gaim plugin directory found at $GaimDir\plugins ."
  WriteRegStr HKLM "SOFTWARE\gaim-otr" "gaimdir" "$GaimDir"

  
FunctionEnd
